<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>ProjectACES: Dijkstra Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">ProjectACES
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-attribs">Public Attributes</a> &#124;
<a href="classDijkstra-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Dijkstra Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><a class="el" href="classDijkstra.html" title="Dijkstra class.">Dijkstra</a> class.  
 <a href="classDijkstra.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="dijkstra_8hpp_source.html">dijkstra.hpp</a>&gt;</code></p>
<div class="dynheader">
Collaboration diagram for Dijkstra:</div>
<div class="dyncontent">
<div class="center"><img src="classDijkstra__coll__graph.png" border="0" usemap="#aDijkstra_coll__map" alt="Collaboration graph"/></div>
<map name="aDijkstra_coll__map" id="aDijkstra_coll__map">
<area shape="rect" title="Dijkstra class." alt="" coords="25,109,98,136"/>
<area shape="rect" href="structDijkstra__node.html" title="Dijkstra_node struct." alt="" coords="5,5,117,32"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a4d2309428b0fb6a81f19fa3d7cd8a9c1"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDijkstra.html#a4d2309428b0fb6a81f19fa3d7cd8a9c1">Dijkstra</a> (int v_nr_nodes)</td></tr>
<tr class="memdesc:a4d2309428b0fb6a81f19fa3d7cd8a9c1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor for random generation.  <a href="classDijkstra.html#a4d2309428b0fb6a81f19fa3d7cd8a9c1">More...</a><br /></td></tr>
<tr class="separator:a4d2309428b0fb6a81f19fa3d7cd8a9c1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2e2995241cd0f7c7e467fac8a20d8978"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDijkstra.html#a2e2995241cd0f7c7e467fac8a20d8978">Dijkstra</a> (int **v_maze, int v_nr_nodes)</td></tr>
<tr class="memdesc:a2e2995241cd0f7c7e467fac8a20d8978"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor for manual generation.  <a href="classDijkstra.html#a2e2995241cd0f7c7e467fac8a20d8978">More...</a><br /></td></tr>
<tr class="separator:a2e2995241cd0f7c7e467fac8a20d8978"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5f4a99a63b92805a304dea947ac69db5"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDijkstra.html#a5f4a99a63b92805a304dea947ac69db5">~Dijkstra</a> ()</td></tr>
<tr class="memdesc:a5f4a99a63b92805a304dea947ac69db5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor.  <a href="classDijkstra.html#a5f4a99a63b92805a304dea947ac69db5">More...</a><br /></td></tr>
<tr class="separator:a5f4a99a63b92805a304dea947ac69db5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4c13d9d8d5166d78e7b1827a3bfdb42a"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDijkstra.html#a4c13d9d8d5166d78e7b1827a3bfdb42a">solve_dijkstra</a> ()</td></tr>
<tr class="memdesc:a4c13d9d8d5166d78e7b1827a3bfdb42a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function for solving the maze.  <a href="classDijkstra.html#a4c13d9d8d5166d78e7b1827a3bfdb42a">More...</a><br /></td></tr>
<tr class="separator:a4c13d9d8d5166d78e7b1827a3bfdb42a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aeb48f10e0a5d100eadde3084c1055b9f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDijkstra.html#aeb48f10e0a5d100eadde3084c1055b9f">alloc_mem</a> ()</td></tr>
<tr class="memdesc:aeb48f10e0a5d100eadde3084c1055b9f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Function for allocating attributes to memory.  <a href="classDijkstra.html#aeb48f10e0a5d100eadde3084c1055b9f">More...</a><br /></td></tr>
<tr class="separator:aeb48f10e0a5d100eadde3084c1055b9f"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-attribs"></a>
Public Attributes</h2></td></tr>
<tr class="memitem:a7994b590ca8f02bf1577adec2d5ac1c5"><td class="memItemLeft" align="right" valign="top">int **&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDijkstra.html#a7994b590ca8f02bf1577adec2d5ac1c5">visited</a></td></tr>
<tr class="memdesc:a7994b590ca8f02bf1577adec2d5ac1c5"><td class="mdescLeft">&#160;</td><td class="mdescRight">The visited nodes.  <a href="classDijkstra.html#a7994b590ca8f02bf1577adec2d5ac1c5">More...</a><br /></td></tr>
<tr class="separator:a7994b590ca8f02bf1577adec2d5ac1c5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4c6686b282d5cf37a96c8c216dc84bef"><td class="memItemLeft" align="right" valign="top">int **&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDijkstra.html#a4c6686b282d5cf37a96c8c216dc84bef">maze</a></td></tr>
<tr class="memdesc:a4c6686b282d5cf37a96c8c216dc84bef"><td class="mdescLeft">&#160;</td><td class="mdescRight">The maze.  <a href="classDijkstra.html#a4c6686b282d5cf37a96c8c216dc84bef">More...</a><br /></td></tr>
<tr class="separator:a4c6686b282d5cf37a96c8c216dc84bef"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a038c1f4d110df6114080878c74039fcf"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDijkstra.html#a038c1f4d110df6114080878c74039fcf">nr_nodes</a></td></tr>
<tr class="memdesc:a038c1f4d110df6114080878c74039fcf"><td class="mdescLeft">&#160;</td><td class="mdescRight">The size of the maze.  <a href="classDijkstra.html#a038c1f4d110df6114080878c74039fcf">More...</a><br /></td></tr>
<tr class="separator:a038c1f4d110df6114080878c74039fcf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a324563e8b4f66022c85870e71064e38e"><td class="memItemLeft" align="right" valign="top">struct <a class="el" href="structDijkstra__node.html">Dijkstra_node</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDijkstra.html#a324563e8b4f66022c85870e71064e38e">starting_node</a></td></tr>
<tr class="memdesc:a324563e8b4f66022c85870e71064e38e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Starting node in the maze.  <a href="classDijkstra.html#a324563e8b4f66022c85870e71064e38e">More...</a><br /></td></tr>
<tr class="separator:a324563e8b4f66022c85870e71064e38e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6cd0a788a66dc3c191d38050337687de"><td class="memItemLeft" align="right" valign="top">struct <a class="el" href="structDijkstra__node.html">Dijkstra_node</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classDijkstra.html#a6cd0a788a66dc3c191d38050337687de">target_node</a></td></tr>
<tr class="memdesc:a6cd0a788a66dc3c191d38050337687de"><td class="mdescLeft">&#160;</td><td class="mdescRight">Target node in the maze.  <a href="classDijkstra.html#a6cd0a788a66dc3c191d38050337687de">More...</a><br /></td></tr>
<tr class="separator:a6cd0a788a66dc3c191d38050337687de"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p><a class="el" href="classDijkstra.html" title="Dijkstra class.">Dijkstra</a> class. </p>
<p>Is used to create the input object. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a4d2309428b0fb6a81f19fa3d7cd8a9c1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4d2309428b0fb6a81f19fa3d7cd8a9c1">&#9670;&nbsp;</a></span>Dijkstra() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Dijkstra::Dijkstra </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>v_nr_nodes</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Constructor for random generation. </p>
<p>This constructor is used when we want to randomly generate the maze.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">v_nr_nodes</td><td>number of nodes of the matrix. Used to know how much memory to allocate. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="classDijkstra.html#a038c1f4d110df6114080878c74039fcf" title="The size of the maze.">nr_nodes</a> </dd>
<dd>
<a class="el" href="classDijkstra.html#aeb48f10e0a5d100eadde3084c1055b9f" title="Function for allocating attributes to memory.">alloc_mem()</a> </dd></dl>

</div>
</div>
<a id="a2e2995241cd0f7c7e467fac8a20d8978"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2e2995241cd0f7c7e467fac8a20d8978">&#9670;&nbsp;</a></span>Dijkstra() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Dijkstra::Dijkstra </td>
          <td>(</td>
          <td class="paramtype">int **&#160;</td>
          <td class="paramname"><em>v_maze</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>v_nr_nodes</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Constructor for manual generation. </p>
<p>This constructor is used when we want to randomly generate the maze.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">v_maze</td><td>matrix got as input (file or keyboard). </td></tr>
    <tr><td class="paramname">v_nr_nodes</td><td>number of nodes of the matrix. Used to know how much memory to allocate. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="classDijkstra.html#a038c1f4d110df6114080878c74039fcf" title="The size of the maze.">nr_nodes</a> </dd>
<dd>
<a class="el" href="classDijkstra.html#a4c6686b282d5cf37a96c8c216dc84bef" title="The maze.">maze</a> </dd>
<dd>
<a class="el" href="classDijkstra.html#aeb48f10e0a5d100eadde3084c1055b9f" title="Function for allocating attributes to memory.">alloc_mem()</a> </dd></dl>

</div>
</div>
<a id="a5f4a99a63b92805a304dea947ac69db5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5f4a99a63b92805a304dea947ac69db5">&#9670;&nbsp;</a></span>~Dijkstra()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Dijkstra::~Dijkstra </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Destructor. </p>
<p>It is also used to delete the maze and visited attributes from the memory at the end of the program.</p>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="classDijkstra.html#a4c6686b282d5cf37a96c8c216dc84bef" title="The maze.">maze</a> </dd>
<dd>
<a class="el" href="classDijkstra.html#a7994b590ca8f02bf1577adec2d5ac1c5" title="The visited nodes.">visited</a> </dd></dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="aeb48f10e0a5d100eadde3084c1055b9f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aeb48f10e0a5d100eadde3084c1055b9f">&#9670;&nbsp;</a></span>alloc_mem()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Dijkstra::alloc_mem </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Function for allocating attributes to memory. </p>
<p>It calls <a class="el" href="dijkstra_8cpp.html#a548cc8f638634e2b33f6121422f48e3d" title="Function for allocating variables to memory.">alloc_mem_matrix()</a> function to allocate the maze and visited attributes to memory</p>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="classDijkstra.html#a4c6686b282d5cf37a96c8c216dc84bef" title="The maze.">maze</a> </dd>
<dd>
<a class="el" href="classDijkstra.html#a7994b590ca8f02bf1577adec2d5ac1c5" title="The visited nodes.">visited</a> </dd>
<dd>
<a class="el" href="dijkstra_8cpp.html#a548cc8f638634e2b33f6121422f48e3d" title="Function for allocating variables to memory.">alloc_mem_matrix()</a> </dd></dl>

</div>
</div>
<a id="a4c13d9d8d5166d78e7b1827a3bfdb42a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4c13d9d8d5166d78e7b1827a3bfdb42a">&#9670;&nbsp;</a></span>solve_dijkstra()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int Dijkstra::solve_dijkstra </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Function for solving the maze. </p>
<p>This function is called after the nr_nodes, maze, starting_node and target node received values from the user. At the end it will overwrite the <a class="el" href="classDijkstra.html#a7994b590ca8f02bf1577adec2d5ac1c5" title="The visited nodes.">Dijkstra::visited</a> attribute to show the path of the solved maze, assign to the <a class="el" href="classDijkstra.html#a6cd0a788a66dc3c191d38050337687de" title="Target node in the maze.">Dijkstra::target_node</a> the <a class="el" href="structDijkstra__node.html#aaa425cda19cfa6c2c7795805da27ea3b" title="the DISTANCE in the from the starting node to the current node">Dijkstra_node::dist</a> (the cost from start to finish).</p>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="classDijkstra.html#a4c6686b282d5cf37a96c8c216dc84bef" title="The maze.">maze</a> </dd>
<dd>
<a class="el" href="classDijkstra.html#a7994b590ca8f02bf1577adec2d5ac1c5" title="The visited nodes.">visited</a> </dd>
<dd>
<a class="el" href="classDijkstra.html#a324563e8b4f66022c85870e71064e38e" title="Starting node in the maze.">starting_node</a> </dd>
<dd>
<a class="el" href="classDijkstra.html#a6cd0a788a66dc3c191d38050337687de" title="Target node in the maze.">target_node</a> </dd></dl>
<dl class="section return"><dt>Returns</dt><dd>1 if the maze can be solved. -1 if the maze can't be solved. </dd></dl>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="a4c6686b282d5cf37a96c8c216dc84bef"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4c6686b282d5cf37a96c8c216dc84bef">&#9670;&nbsp;</a></span>maze</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int** Dijkstra::maze</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>The maze. </p>
<p>The actual maze that will be solved using the DIJKSTRA algorithm. It can be generated randomly or gotten manually. </p>

</div>
</div>
<a id="a038c1f4d110df6114080878c74039fcf"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a038c1f4d110df6114080878c74039fcf">&#9670;&nbsp;</a></span>nr_nodes</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int Dijkstra::nr_nodes</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>The size of the maze. </p>
<p>Tha maze will be a matrix of size &lt;nr_nodes&gt;x&lt;nr_nodes&gt;. </p>

</div>
</div>
<a id="a324563e8b4f66022c85870e71064e38e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a324563e8b4f66022c85870e71064e38e">&#9670;&nbsp;</a></span>starting_node</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">struct <a class="el" href="structDijkstra__node.html">Dijkstra_node</a> Dijkstra::starting_node</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Starting node in the maze. </p>
<p>It contains the coordinates (row and collumn) and the distance is always 0. </p>

</div>
</div>
<a id="a6cd0a788a66dc3c191d38050337687de"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6cd0a788a66dc3c191d38050337687de">&#9670;&nbsp;</a></span>target_node</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">struct <a class="el" href="structDijkstra__node.html">Dijkstra_node</a> Dijkstra::target_node</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Target node in the maze. </p>
<p>It contains the coordinates (row and collumn), it's distance is assigned at the end of the algorithm. </p>

</div>
</div>
<a id="a7994b590ca8f02bf1577adec2d5ac1c5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7994b590ca8f02bf1577adec2d5ac1c5">&#9670;&nbsp;</a></span>visited</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int** Dijkstra::visited</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>The visited nodes. </p>
<p>It is used in the algorithm to tell which node was already visited. </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>include/<a class="el" href="dijkstra_8hpp_source.html">dijkstra.hpp</a></li>
<li>src/<a class="el" href="dijkstra_8cpp.html">dijkstra.cpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
